from dataclasses import dataclass, field

from .base import Paysite, Service_Post, Service_User


@dataclass
class User(Service_User):
    def profile(self, artist: dict) -> str:
        return f"https://onlyfans.com/{(artist or {}).get('public_id') or (artist or {}).get('id')}"


@dataclass
class Post(Service_Post):
    def link(self, post_id: str, user_id: str) -> str:
        return f"https://onlyfans.com/{post_id}/{user_id}"


@dataclass
class OnlyFans(Paysite):
    name: str = "onlyfans"
    title: str = "OnlyFans"
    user: User = field(default_factory=User)
    post: Post = field(default_factory=Post)
    color: str = "#008ccf"
